 // mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata clear
mata set matastrict on
void m_efrontiermwos(string scalar varlist, real matrix vecweights, real scalar nport, string scalar touse, string scalar casewis, real matrix covmatrix, real matrix mrets)
{
real matrix r, COV, W, MR, wefwos, refwos, sdefwos
real vector gmvp, pmv
real scalar j, rgmvp, maxR,delta, Ri, i
real scalar retp, riskp, varp
st_view(r=.,.,tokens(varlist), touse)
if (cols(covmatrix)<=1) {
 COV=m_expvar(r,casewis)
 }
else {
  COV=covmatrix
}  
 
if (rows(mrets)<=1) {
  MR=m_exprets(r, casewis)
}
else {
  MR=mrets[.,1]
} 

  wefwos=J(nport,rows(MR),.)
  refwos=J(nport,1,.)
  sdefwos=J(nport,1,.)
  gmvp = m_gmvportwos2(varlist, vecweights, touse, casewis, covmatrix, mrets)
   rgmvp = cross(gmvp,MR)
   maxR=max(MR)
  Ri=rgmvp
  delta=(maxR - rgmvp) / (nport-1) 
  for (j=1; j<=nport; j++) {
    
    pmv = m_mvportwos2(varlist, Ri, vecweights, touse, casewis, covmatrix, mrets)
	refwos[j,1]=cross(pmv,MR)	
    sdefwos[j,1]=sqrt(cross(pmv,COV)*pmv)

   for (i=1; i<=cols(COV); i++) { 
      wefwos[j,i]=pmv[i]
	}
   Ri=Ri+delta
  }
st_matrix("r(cov)",COV)
st_matrix("r(refwos)",refwos)
st_matrix("r(wefwos)",wefwos)
st_matrix("r(sdefwos)",sdefwos)
st_matrix("r(exprets)",MR)

}
end
mata: mata mosave m_efrontiermwos(), dir(PERSONAL) replace
