// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata set matastrict on

mata:
real vector function m_exprets(real matrix r, real scalar lamda, real matrix W, string scalar casewis, real matrix weights)
{ real vector Mr, MR
real scalar N, i, j

  if (lamda==-1) {
   if (casewis!="") {
   MR=exp(m_mean1(r,weights)) - J(1,cols(r),1)
   }
   else {
    MR=J(1,cols(r),0)
    for (i=1; i<=cols(r); i++) {
      MR[1,i] = exp(m_mean1(r[.,i],weights)) - 1
    }
   }
   W=weights[.,1]
   }
   else {
   N=rows(r)
   W=J(N,1,.)
   j=0
     for (i=1; i<=N; i++) {
 	   W[i,1] = (1-lamda)*(lamda)^(N-i)
	   j=j+W[i,1]
	 }
	 W = W + J(N,1,(1-j)/N)
   	
   MR = exp(m_mean1(r,W)) - J(1,cols(r),1)
   }
   return(MR')
}   
end
mata: mata mosave m_exprets(), dir(PERSONAL) replace
