// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata set matastrict on
mata:
real matrix m_variance1(real matrix X, |real colvector w)
{
	real rowvector	CP, w1
	real rowvector	means
	real scalar	n 

	if (args()==1 | w==J(1,1,1)) {
	  w = 1
	  w1 = 1
	}  
	else {
      w1=w+rowsum(X,1)- rowsum(X,1)
	  w1=w1:/colsum(w1)
	  w1=w1:*colnonmissing(w1)
	}
    
	CP = quadcross(w1,0, X,1)
	n  = cols(CP)
	means = CP[|1\n-1|] :/ CP[n]
	if (missing(CP) | CP[n]==0) return(J(cols(X), cols(X), .))
	return(crossdev(X,0,means, w1, X,0,means) :/ (CP[n]-1))
}

end
mata: mata mosave m_variance1(), dir(PERSONAL) replace
