// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx

version 11.0
mata:
mata set matastrict on
real matrix function m_calcvar(real matrix r, real matrix W)
{ real matrix COVA, COVA1,r3, DMRET, MEANRET
  real vector r1,r2, COLN, rweights
real scalar i, j, k,N,p, sp
    COVA=J(cols(r),cols(r),.)
    for (i=1; i<=cols(r); i++) {
	 r1=r[.,i]
	 COVA[i,i]=m_variance1(r1, W)
	 for (j=i+1; j<=cols(r); j++) {
	  r2=r[.,j]
	  r3=r1,r2
	  COVA1=m_variance1(r3, W)
	  COVA[i,j] = COVA1[1,2]
	  COVA[j,i] = COVA[i,j]
     }
	}

   return(COVA)
   st_numscalar("r(cov)",COVA)
}   
end
mata: mata mosave m_calcvar(), dir(PERSONAL) replace
