// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata set matastrict on
mata:

real scalar function m_getmaxr(real matrix MR, real matrix VW)
{
 real matrix MRVW, MRVWsort
 real rowvector MRVWsum, VWsum
 real scalar maxr, i, sigue
 
	  MRVW=MR:*VW
      MRVWsort=MR,VW, MRVW
	  MRVWsort=sort(MRVWsort,-1)
      
	  MRVWsum=runningsum(MRVWsort[.,3])
	  VWsum=runningsum(MRVWsort[.,2])
	  i=0
	  sigue=1
	  while (i<=rows(MR) & sigue) { 
	     i++
		 if (VWsum[i]>1) {
		   sigue=0
		 } 
	  }
	  maxr=MRVWsum[i-1] + (1-VWsum[i-1])* MRVWsort[i,1] 
      return(maxr) 
}
end
mata: mata mosave m_getmaxr(), dir(PERSONAL) replace

