//*! m_simport, version 1.0, Sep 2013
// version 2.0, Oct 2015
//* Author: Alberto Dorantes, ITESM, Quertaro, Mxico
version 11.0
mata:
mata set matastrict on
real matrix function m_simport(string scalar varlist, real scalar nport, string scalar touse, string scalar casewis)
{
real matrix r, MR, COV, matp, vecSD, matriz, W
real colvector vecR, p
real scalar numport, i
real matrix W1
st_view(r=.,.,tokens(varlist), touse)
W1=J(1,1,1)
MR=m_exprets(r, -1, W, casewis, W1)
COV=m_expvar(r, -1, W, casewis, W1)
matp=m_genportaal(nport,cols(r))
numport=cols(matp)
vecR=cross(matp,MR)
vecSD=J(numport,1,0)
for (i=1; i<=numport; i++) {
    p=matp[.,i]
	vecSD[i]=sqrt((p'*COV)*p)
} 
matriz=matp',vecR,vecSD
st_numscalar("r(numobs)",numport)
st_numscalar("r(numvars)",rows(matp))
return(matriz)
}

end
mata: mata mosave m_simport(), dir(PERSONAL) replace
