// mvport package v2
// Author: Alberto Dorantes, July, 2016
// cdorante@itesm.mx
version 11.0
mata:
mata set matastrict on

mata:
real matrix function m_varrets(string scalar varlist, string scalar touse, real scalar lamda, string scalar casewise, real matrix weights)
{ real matrix COVA, r, W
   st_view(r=.,.,tokens(varlist), touse)
   COVA=m_expvar(r, lamda, W, casewise, weights)
   st_matrix("r(cov)",COVA)
   if (W==J(1,1,1)) { 
     W=J(rows(r), 1, 1/rows(r))
   } 
   st_matrix("r(W)", W)
   st_numscalar("r(N)",rows(r))
   return(COVA)
}   
end
mata: mata mosave m_varrets(), dir(PERSONAL) replace
